﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Vehicles
{
    public class Demo
    {
        static void Main(string[] args)
        {
            HashSet<IVehicle> vehicles = new HashSet<IVehicle>();
            IVehicle carA = new Car("1B1111", 5),
                    carB = new Car("2A2222", 50),
                    planeA = new Plane("OK-CAB", 20),
                    planeB = new Plane("OK-BAC", 50);
            vehicles.Add(carA);
            vehicles.Add(carB);
            vehicles.Add(planeA);
            vehicles.Add(planeB);
            print(vehicles);
            refuel(vehicles);
            print(vehicles);
            
            Console.WriteLine("Car A has gone: " + carA.Go(600));
            Console.WriteLine("Car B has gone: " + carB.Go(75));
            Console.WriteLine("Plane A has flown: " + planeA.Go(490));
            Console.WriteLine("Plane B has flown: " + planeB.Go(190));
            print(vehicles);

            Console.WriteLine("Car A has gone: " + carA.Go(220));
            Console.WriteLine("Car B has gone: " + carB.Go(10));
            Console.WriteLine("Plane A has flown: " + planeA.Go(20));
            Console.WriteLine("Plane B has flown: " + planeB.Go(20));
            print(vehicles);
            refuel(vehicles);
            print(vehicles);

            Console.WriteLine("Car A has gone: " + carA.Go(220));
            Console.WriteLine("Car B has gone: " + carB.Go(10));
            Console.WriteLine("Plane A has flown: " + planeA.Go(20));
            Console.WriteLine("Plane B has flown: " + planeB.Go(20));
            print(vehicles);

            Console.ReadLine();
        }

        private static void refuel(HashSet<IVehicle> vehicles)
        {
            foreach (IVehicle v in vehicles)
            {
                if (v is Car)
                {
                    v.Refuel(40);
                }
                else
                {
                    v.Refuel(100);
                }
            }
        }

        private static void print(HashSet<IVehicle> vehicles)
        {
            foreach(IVehicle v in vehicles)
            {
                Console.WriteLine(v);
            }
        }
    }
}
