﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Vehicles
{
    public interface IVehicle
    {
        double Refuel(double fuel);
        int Go(int distance);
        double GetConsumption();
        int GetDistance();
    }

    public abstract class AbstractVehicle:IVehicle
    {
        private double consumption, fuel;
        private int gone;

        public AbstractVehicle(double consumption)
        {
            this.consumption = consumption;
            this.gone = 0;
            this.fuel = 0;
        }

        public double GetConsumption()
        {
            return consumption;
        }

        public int GetDistance()
        {
            return gone;
        }

        public int Go(int distance)
        {
            if (distance * consumption / 100 <= fuel)
            {
                fuel -= distance * consumption / 100;
                gone += distance;
                return distance;
            }
            return 0;
        }
        public double Refuel(double fuel)
        {
            this.fuel += fuel;
            return fuel;
        }

        public override string ToString()
        {
            return  gone + " km so far and remains " + fuel + " l of fuel." ;
        }

    }
    public class Car : AbstractVehicle
    {
        private string id;

        public Car(string id,double consumption):base(consumption)
        {
            this.id = id;
        }
        

        
        public override string ToString()
        {
            return "Car " + id + "has gone " +  base.ToString();
        }
    }

    public class Plane : AbstractVehicle
    {
        private string imatriculation;

        public Plane(string id, double consumption):base(consumption)
        {
            this.imatriculation = id;
        }

        public override string ToString()
        {
            return "Plane " + imatriculation + "has flown " + base.ToString();
        }
    }
}
